// services/on_device_model/public/mojom/on_device_model.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "services/on_device_model/public/mojom/on_device_model.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/on_device_model/public/mojom/on_device_model.mojom-params-data.h"
namespace on_device_model {
namespace mojom {

NOINLINE static const char* PerformanceClassToStringHelper(PerformanceClass value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case PerformanceClass::kError:
      return "kError";
    case PerformanceClass::kVeryLow:
      return "kVeryLow";
    case PerformanceClass::kLow:
      return "kLow";
    case PerformanceClass::kMedium:
      return "kMedium";
    case PerformanceClass::kHigh:
      return "kHigh";
    case PerformanceClass::kVeryHigh:
      return "kVeryHigh";
    default:
      return nullptr;
  }
}

std::string PerformanceClassToString(PerformanceClass value) {
  const char *str = PerformanceClassToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown PerformanceClass value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, PerformanceClass value) {
  return os << PerformanceClassToString(value);
}

namespace internal {
// static
bool LoadModelResult_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context,
    bool inlined) {
  if (!data) {
    DCHECK(!inlined);
    return true;
  }

  // If it is inlined, the alignment is already enforced by its enclosing
  // object. We don't have to validate that.
  DCHECK(!inlined || mojo::internal::IsAligned(data));

  if (!inlined &&
      !mojo::internal::ValidateNonInlinedUnionHeaderAndClaimMemory(
          data, validation_context)) {
    return false;
  }

  const LoadModelResult_Data* object = static_cast<const LoadModelResult_Data*>(data);

  if (inlined && object->is_null())
    return true;

  switch (object->tag) {

    case LoadModelResult_Tag::kModel: {

      if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
              object->data.f_model, 1, validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateHandleOrInterface(object->data.f_model,
                                                     validation_context)) {
        return false;
      }
      return true;
    }
    case LoadModelResult_Tag::kError: {

      if (!mojo::internal::ValidatePointerNonNullable(
              object->data.f_error, 2, validation_context)) {
        return false;
      }
      constexpr const mojo::internal::ContainerValidateParams& error_validate_params =
          mojo::internal::GetArrayValidator<0, false, nullptr>();
      if (!mojo::internal::ValidateContainer(object->data.f_error, validation_context,
                                             &error_validate_params)) {
        return false;
      }
      return true;
    }
    default: {

      ReportValidationError(
          validation_context,
          mojo::internal::VALIDATION_ERROR_UNKNOWN_UNION_TAG,
          "unknown tag in LoadModelResult");
      return false;
    }
  }
}


// static
bool ModelAssets_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ModelAssets_Data* object =
      static_cast<const ModelAssets_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->sp_model, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->model, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->weights, validation_context))
    return false;

  return true;
}

ModelAssets_Data::ModelAssets_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool StreamingResponder_OnResponse_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const StreamingResponder_OnResponse_Params_Data* object =
      static_cast<const StreamingResponder_OnResponse_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->text, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& text_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->text, validation_context,
                                         &text_validate_params)) {
    return false;
  }

  return true;
}

StreamingResponder_OnResponse_Params_Data::StreamingResponder_OnResponse_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool StreamingResponder_OnComplete_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const StreamingResponder_OnComplete_Params_Data* object =
      static_cast<const StreamingResponder_OnComplete_Params_Data*>(data);

  return true;
}

StreamingResponder_OnComplete_Params_Data::StreamingResponder_OnComplete_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool OnDeviceModel_Execute_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const OnDeviceModel_Execute_Params_Data* object =
      static_cast<const OnDeviceModel_Execute_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->input, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& input_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->input, validation_context,
                                         &input_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->response, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->response,
                                                 validation_context)) {
    return false;
  }

  return true;
}

OnDeviceModel_Execute_Params_Data::OnDeviceModel_Execute_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool OnDeviceModelService_LoadModel_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const OnDeviceModelService_LoadModel_Params_Data* object =
      static_cast<const OnDeviceModelService_LoadModel_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->assets, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->assets, validation_context))
    return false;

  return true;
}

OnDeviceModelService_LoadModel_Params_Data::OnDeviceModelService_LoadModel_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool OnDeviceModelService_LoadModel_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const OnDeviceModelService_LoadModel_ResponseParams_Data* object =
      static_cast<const OnDeviceModelService_LoadModel_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateInlinedUnionNonNullable(
          object->result, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateInlinedUnion(object->result, validation_context))
    return false;

  return true;
}

OnDeviceModelService_LoadModel_ResponseParams_Data::OnDeviceModelService_LoadModel_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool OnDeviceModelService_GetEstimatedPerformanceClass_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const OnDeviceModelService_GetEstimatedPerformanceClass_Params_Data* object =
      static_cast<const OnDeviceModelService_GetEstimatedPerformanceClass_Params_Data*>(data);

  return true;
}

OnDeviceModelService_GetEstimatedPerformanceClass_Params_Data::OnDeviceModelService_GetEstimatedPerformanceClass_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool OnDeviceModelService_GetEstimatedPerformanceClass_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const OnDeviceModelService_GetEstimatedPerformanceClass_ResponseParams_Data* object =
      static_cast<const OnDeviceModelService_GetEstimatedPerformanceClass_ResponseParams_Data*>(data);


  if (!::on_device_model::mojom::internal::PerformanceClass_Data
        ::Validate(object->performance_class, validation_context))
    return false;

  return true;
}

OnDeviceModelService_GetEstimatedPerformanceClass_ResponseParams_Data::OnDeviceModelService_GetEstimatedPerformanceClass_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace on_device_model

namespace perfetto {

// static
void TraceFormatTraits<::on_device_model::mojom::PerformanceClass>::WriteIntoTrace(
   perfetto::TracedValue context, ::on_device_model::mojom::PerformanceClass value) {
  return std::move(context).WriteString(::on_device_model::mojom::PerformanceClassToString(value));
}

} // namespace perfetto