// services/on_device_model/public/mojom/on_device_model.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_ON_DEVICE_MODEL_PUBLIC_MOJOM_ON_DEVICE_MODEL_MOJOM_H_
#define SERVICES_ON_DEVICE_MODEL_PUBLIC_MOJOM_ON_DEVICE_MODEL_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/on_device_model/public/mojom/on_device_model.mojom-shared.h"
#include "services/on_device_model/public/mojom/on_device_model.mojom-forward.h"
#include "mojo/public/mojom/base/file.mojom.h"
#include "sandbox/policy/mojom/context.mojom-forward.h"
#include "sandbox/policy/mojom/sandbox.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "services/on_device_model/public/cpp/model_assets_mojom_traits.h"




namespace on_device_model::mojom {

class StreamingResponderProxy;

template <typename ImplRefTraits>
class StreamingResponderStub;

class StreamingResponderRequestValidator;


class StreamingResponder
    : public StreamingResponderInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = StreamingResponderInterfaceBase;
  using Proxy_ = StreamingResponderProxy;

  template <typename ImplRefTraits>
  using Stub_ = StreamingResponderStub<ImplRefTraits>;

  using RequestValidator_ = StreamingResponderRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnResponseMinVersion = 0,
    kOnCompleteMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct OnResponse_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct OnComplete_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~StreamingResponder() = default;

  
  virtual void OnResponse(const std::string& text) = 0;

  
  virtual void OnComplete() = 0;
};

class OnDeviceModelProxy;

template <typename ImplRefTraits>
class OnDeviceModelStub;

class OnDeviceModelRequestValidator;


class OnDeviceModel
    : public OnDeviceModelInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = OnDeviceModelInterfaceBase;
  using Proxy_ = OnDeviceModelProxy;

  template <typename ImplRefTraits>
  using Stub_ = OnDeviceModelStub<ImplRefTraits>;

  using RequestValidator_ = OnDeviceModelRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kExecuteMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct Execute_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~OnDeviceModel() = default;

  
  virtual void Execute(const std::string& input, ::mojo::PendingRemote<StreamingResponder> response) = 0;
};

class OnDeviceModelServiceProxy;

template <typename ImplRefTraits>
class OnDeviceModelServiceStub;

class OnDeviceModelServiceRequestValidator;
class OnDeviceModelServiceResponseValidator;


class OnDeviceModelService
    : public OnDeviceModelServiceInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr auto kServiceSandbox = sandbox::mojom::Sandbox::kOnDeviceModelExecution;
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = OnDeviceModelServiceInterfaceBase;
  using Proxy_ = OnDeviceModelServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = OnDeviceModelServiceStub<ImplRefTraits>;

  using RequestValidator_ = OnDeviceModelServiceRequestValidator;
  using ResponseValidator_ = OnDeviceModelServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kLoadModelMinVersion = 0,
    kGetEstimatedPerformanceClassMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct LoadModel_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct GetEstimatedPerformanceClass_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~OnDeviceModelService() = default;


  using LoadModelCallback = base::OnceCallback<void(LoadModelResultPtr)>;
  
  virtual void LoadModel(on_device_model::ModelAssets assets, LoadModelCallback callback) = 0;


  using GetEstimatedPerformanceClassCallback = base::OnceCallback<void(PerformanceClass)>;
  
  virtual void GetEstimatedPerformanceClass(GetEstimatedPerformanceClassCallback callback) = 0;
};



class  StreamingResponderProxy
    : public StreamingResponder {
 public:
  using InterfaceType = StreamingResponder;

  explicit StreamingResponderProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnResponse(const std::string& text) final;
  
  void OnComplete() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  OnDeviceModelProxy
    : public OnDeviceModel {
 public:
  using InterfaceType = OnDeviceModel;

  explicit OnDeviceModelProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Execute(const std::string& input, ::mojo::PendingRemote<StreamingResponder> response) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  OnDeviceModelServiceProxy
    : public OnDeviceModelService {
 public:
  using InterfaceType = OnDeviceModelService;

  explicit OnDeviceModelServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void LoadModel(on_device_model::ModelAssets assets, LoadModelCallback callback) final;
  
  void GetEstimatedPerformanceClass(GetEstimatedPerformanceClassCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  StreamingResponderStubDispatch {
 public:
  static bool Accept(StreamingResponder* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      StreamingResponder* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<StreamingResponder>>
class StreamingResponderStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  StreamingResponderStub() = default;
  ~StreamingResponderStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return StreamingResponderStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return StreamingResponderStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  OnDeviceModelStubDispatch {
 public:
  static bool Accept(OnDeviceModel* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      OnDeviceModel* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<OnDeviceModel>>
class OnDeviceModelStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  OnDeviceModelStub() = default;
  ~OnDeviceModelStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OnDeviceModelStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OnDeviceModelStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  OnDeviceModelServiceStubDispatch {
 public:
  static bool Accept(OnDeviceModelService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      OnDeviceModelService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<OnDeviceModelService>>
class OnDeviceModelServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  OnDeviceModelServiceStub() = default;
  ~OnDeviceModelServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OnDeviceModelServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OnDeviceModelServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  StreamingResponderRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  OnDeviceModelRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  OnDeviceModelServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  OnDeviceModelServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};






class  LoadModelResult {
 public:
  using DataView = LoadModelResultDataView;
  using Data_ = internal::LoadModelResult_Data;
  using Tag = Data_::LoadModelResult_Tag;

  template <typename... Args>
  static LoadModelResultPtr New(Args&&... args) {
    static_assert(
        sizeof...(args) < 0,
        "Do not use Union::New(); to create a union of a given subtype, use "
        "New<SubType>(), not New() followed by set_<sub_type>(). To represent "
        "an empty union, mark the field or parameter as nullable in the mojom "
        "definition.");
    return nullptr;
  }
  // Construct an instance holding |model|.
  static LoadModelResultPtr
  NewModel(
      ::mojo::PendingRemote<OnDeviceModel> model) {
    auto result = LoadModelResultPtr(absl::in_place);
    result->set_model(std::move(model));
    return result;
  }
  // Construct an instance holding |error|.
  static LoadModelResultPtr
  NewError(
      const std::string& error) {
    auto result = LoadModelResultPtr(absl::in_place);
    result->set_error(std::move(error));
    return result;
  }

  template <typename U>
  static LoadModelResultPtr From(const U& u) {
    return mojo::TypeConverter<LoadModelResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, LoadModelResult>::Convert(*this);
  }

  LoadModelResult();
  ~LoadModelResult();
  // Delete the copy constructor and copy assignment operators because `data_`
  // contains raw pointers that must not be copied.
  LoadModelResult(const LoadModelResult& other) = delete;
  LoadModelResult& operator=(const LoadModelResult& other) = delete;

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = LoadModelResultPtr>
  LoadModelResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, LoadModelResult>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename T,
            typename std::enable_if<std::is_same<
                T, LoadModelResult>::value>::type* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  Tag which() const {
    return tag_;
  }


  
  bool is_model() const { return tag_ == Tag::kModel; }

  
  ::mojo::PendingRemote<OnDeviceModel>& get_model() const {
    CHECK(tag_ == Tag::kModel);
    return *(data_.model);
  }

  
  void set_model(
      ::mojo::PendingRemote<OnDeviceModel> model);
  
  bool is_error() const { return tag_ == Tag::kError; }

  
  std::string& get_error() const {
    CHECK(tag_ == Tag::kError);
    return *(data_.error);
  }

  
  void set_error(
      const std::string& error);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        LoadModelResult::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<LoadModelResult::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

 private:
  union Union_ {
    Union_() = default;
    ~Union_() = default;
    ::mojo::PendingRemote<OnDeviceModel>* model;
    std::string* error;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};





class  ModelAssets {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ModelAssets, T>::value>;
  using DataView = ModelAssetsDataView;
  using Data_ = internal::ModelAssets_Data;

  template <typename... Args>
  static ModelAssetsPtr New(Args&&... args) {
    return ModelAssetsPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ModelAssetsPtr From(const U& u) {
    return mojo::TypeConverter<ModelAssetsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ModelAssets>::Convert(*this);
  }


  ModelAssets();

  ModelAssets(
      ::base::File sp_model,
      ::base::File model,
      ::base::File weights);

ModelAssets(const ModelAssets&) = delete;
ModelAssets& operator=(const ModelAssets&) = delete;

  ~ModelAssets();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ModelAssetsPtr>
  ModelAssetsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ModelAssets::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ModelAssets::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ModelAssets::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ModelAssets::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ModelAssets_UnserializedMessageContext<
            UserType, ModelAssets::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ModelAssets::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ModelAssets::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ModelAssets_UnserializedMessageContext<
            UserType, ModelAssets::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ModelAssets::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::base::File sp_model;
  
  ::base::File model;
  
  ::base::File weights;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ModelAssets::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ModelAssets::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ModelAssets::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ModelAssets::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename UnionPtrType>
LoadModelResultPtr LoadModelResult::Clone() const {
  switch (tag_) {
    case Tag::kModel:
      return NewModel(
          mojo::Clone(*data_.model));
    case Tag::kError:
      return NewError(
          mojo::Clone(*data_.error));
  }
  return nullptr;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, LoadModelResult>::value>::type*>
bool LoadModelResult::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::kModel:
      return mojo::Equals(*(data_.model), *(other.data_.model));
    case Tag::kError:
      return mojo::Equals(*(data_.error), *(other.data_.error));
  }

  return false;
}
template <typename StructPtrType>
ModelAssetsPtr ModelAssets::Clone() const {
  return New(
      mojo::Clone(sp_model),
      mojo::Clone(model),
      mojo::Clone(weights)
  );
}

template <typename T, ModelAssets::EnableIfSame<T>*>
bool ModelAssets::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->sp_model, other_struct.sp_model))
    return false;
  if (!mojo::Equals(this->model, other_struct.model))
    return false;
  if (!mojo::Equals(this->weights, other_struct.weights))
    return false;
  return true;
}

template <typename T, ModelAssets::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.sp_model < rhs.sp_model)
    return true;
  if (rhs.sp_model < lhs.sp_model)
    return false;
  if (lhs.model < rhs.model)
    return true;
  if (rhs.model < lhs.model)
    return false;
  if (lhs.weights < rhs.weights)
    return true;
  if (rhs.weights < lhs.weights)
    return false;
  return false;
}


}  // on_device_model::mojom

namespace mojo {


template <>
struct  StructTraits<::on_device_model::mojom::ModelAssets::DataView,
                                         ::on_device_model::mojom::ModelAssetsPtr> {
  static bool IsNull(const ::on_device_model::mojom::ModelAssetsPtr& input) { return !input; }
  static void SetToNull(::on_device_model::mojom::ModelAssetsPtr* output) { output->reset(); }

  static  decltype(::on_device_model::mojom::ModelAssets::sp_model)& sp_model(
       ::on_device_model::mojom::ModelAssetsPtr& input) {
    return input->sp_model;
  }

  static  decltype(::on_device_model::mojom::ModelAssets::model)& model(
       ::on_device_model::mojom::ModelAssetsPtr& input) {
    return input->model;
  }

  static  decltype(::on_device_model::mojom::ModelAssets::weights)& weights(
       ::on_device_model::mojom::ModelAssetsPtr& input) {
    return input->weights;
  }

  static bool Read(::on_device_model::mojom::ModelAssets::DataView input, ::on_device_model::mojom::ModelAssetsPtr* output);
};


template <>
struct  UnionTraits<::on_device_model::mojom::LoadModelResult::DataView,
                                        ::on_device_model::mojom::LoadModelResultPtr> {
  static bool IsNull(const ::on_device_model::mojom::LoadModelResultPtr& input) { return !input; }
  static void SetToNull(::on_device_model::mojom::LoadModelResultPtr* output) { output->reset(); }

  static ::on_device_model::mojom::LoadModelResult::Tag GetTag(const ::on_device_model::mojom::LoadModelResultPtr& input) {
    return input->which();
  }

  static  ::mojo::PendingRemote<::on_device_model::mojom::OnDeviceModel>& model( ::on_device_model::mojom::LoadModelResultPtr& input) {
    return input->get_model();
  }

  static const std::string& error(const ::on_device_model::mojom::LoadModelResultPtr& input) {
    return input->get_error();
  }

  static bool Read(::on_device_model::mojom::LoadModelResult::DataView input, ::on_device_model::mojom::LoadModelResultPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_ON_DEVICE_MODEL_PUBLIC_MOJOM_ON_DEVICE_MODEL_MOJOM_H_