// third_party/blink/public/mojom/loader/resource_cache.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_RESOURCE_CACHE_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_RESOURCE_CACHE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/loader/resource_cache.mojom-shared-internal.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"
#include "url/mojom/url.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"


#include "base/component_export.h"




namespace blink::mojom {
class ResourceCacheContainsResultDataView;



}  // blink::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::ResourceCacheContainsResultDataView> {
  using Data = ::blink::mojom::internal::ResourceCacheContainsResult_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {


enum class ResourceCacheContainsResult_LifecycleState : int32_t {
  
  kUnknown = 0,
  
  kRunning = 1,
  
  kPaused = 2,
  
  kFrozen = 3,
  kMinValue = 0,
  kMaxValue = 3,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, ResourceCacheContainsResult_LifecycleState value);
inline bool IsKnownEnumValue(ResourceCacheContainsResult_LifecycleState value) {
  return internal::ResourceCacheContainsResult_LifecycleState_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class ResourceCacheInterfaceBase {};

using ResourceCachePtrDataView =
    mojo::InterfacePtrDataView<ResourceCacheInterfaceBase>;
using ResourceCacheRequestDataView =
    mojo::InterfaceRequestDataView<ResourceCacheInterfaceBase>;
using ResourceCacheAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ResourceCacheInterfaceBase>;
using ResourceCacheAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ResourceCacheInterfaceBase>;


class ResourceCacheContainsResultDataView {
 public:
  ResourceCacheContainsResultDataView() = default;

  ResourceCacheContainsResultDataView(
      internal::ResourceCacheContainsResult_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  bool is_in_cache() const {
    return data_->is_in_cache;
  }
  inline void GetIpcResponseTimeDataView(
      ::mojo_base::mojom::TimeTicksDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadIpcResponseTime(UserType* output) {
    
    auto* pointer = data_->ipc_response_time.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeTicksDataView>(
        pointer, output, message_);
  }
  bool is_visible() const {
    return data_->is_visible;
  }
  template <typename UserType>
  [[nodiscard]] bool ReadLifecycleState(UserType* output) const {
    auto data_value = data_->lifecycle_state;
    return mojo::internal::Deserialize<::blink::mojom::ResourceCacheContainsResult_LifecycleState>(
        data_value, output);
  }
  ResourceCacheContainsResult_LifecycleState lifecycle_state() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::ResourceCacheContainsResult_LifecycleState>(data_->lifecycle_state));
  }
 private:
  internal::ResourceCacheContainsResult_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // blink::mojom

namespace std {

template <>
struct hash<::blink::mojom::ResourceCacheContainsResult_LifecycleState>
    : public mojo::internal::EnumHashImpl<::blink::mojom::ResourceCacheContainsResult_LifecycleState> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::ResourceCacheContainsResult_LifecycleState, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::ResourceCacheContainsResult_LifecycleState, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::ResourceCacheContainsResult_LifecycleState>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::ResourceCacheContainsResultDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::ResourceCacheContainsResultDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::ResourceCacheContainsResult_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->is_in_cache = Traits::is_in_cache(input);
    decltype(Traits::ipc_response_time(input)) in_ipc_response_time = Traits::ipc_response_time(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->ipc_response_time)::BaseType> ipc_response_time_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::TimeTicksDataView>(
        in_ipc_response_time, ipc_response_time_fragment);
    fragment->ipc_response_time.Set(
        ipc_response_time_fragment.is_null() ? nullptr : ipc_response_time_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->ipc_response_time.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null ipc_response_time in ResourceCacheContainsResult struct");
    fragment->is_visible = Traits::is_visible(input);
    mojo::internal::Serialize<::blink::mojom::ResourceCacheContainsResult_LifecycleState>(
        Traits::lifecycle_state(input), &fragment->lifecycle_state);
  }

  static bool Deserialize(::blink::mojom::internal::ResourceCacheContainsResult_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::ResourceCacheContainsResultDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {

inline void ResourceCacheContainsResultDataView::GetIpcResponseTimeDataView(
    ::mojo_base::mojom::TimeTicksDataView* output) {
  auto pointer = data_->ipc_response_time.Get();
  *output = ::mojo_base::mojom::TimeTicksDataView(pointer, message_);
}



}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::ResourceCacheContainsResult_LifecycleState> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::ResourceCacheContainsResult_LifecycleState value);
};

} // namespace perfetto

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_RESOURCE_CACHE_MOJOM_SHARED_H_