// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AUTHENTICATION_EXTENSIONS_DEVICE_PUBLIC_KEY_OUTPUTS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AUTHENTICATION_EXTENSIONS_DEVICE_PUBLIC_KEY_OUTPUTS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/core/typed_arrays/array_buffer_view_helpers.h"
#include "third_party/blink/renderer/core/typed_arrays/dom_typed_array.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT AuthenticationExtensionsDevicePublicKeyOutputs : public bindings::DictionaryBase {
  
  public:
static AuthenticationExtensionsDevicePublicKeyOutputs* Create() {
  return MakeGarbageCollected<AuthenticationExtensionsDevicePublicKeyOutputs>();
}
static AuthenticationExtensionsDevicePublicKeyOutputs* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<AuthenticationExtensionsDevicePublicKeyOutputs>(isolate);
}
static AuthenticationExtensionsDevicePublicKeyOutputs* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  AuthenticationExtensionsDevicePublicKeyOutputs();
explicit  AuthenticationExtensionsDevicePublicKeyOutputs(v8::Isolate* isolate);

bool hasAuthenticatorOutput() const {
  return has_authenticator_output_;
}
DOMArrayBuffer* authenticatorOutput() const {
  DCHECK(hasAuthenticatorOutput());
return member_authenticator_output_.Get();
}
DOMArrayBuffer* getAuthenticatorOutputOr(DOMArrayBuffer* fallback_value) const {
  if (!hasAuthenticatorOutput()) {
  return fallback_value;
}
return member_authenticator_output_.Get();
}
void setAuthenticatorOutput(DOMArrayBuffer* value) {
  member_authenticator_output_ = value;
has_authenticator_output_ = true;
DCHECK(member_authenticator_output_);
}

bool hasSignature() const {
  return has_signature_;
}
DOMArrayBuffer* signature() const {
  DCHECK(hasSignature());
return member_signature_.Get();
}
DOMArrayBuffer* getSignatureOr(DOMArrayBuffer* fallback_value) const {
  if (!hasSignature()) {
  return fallback_value;
}
return member_signature_.Get();
}
void setSignature(DOMArrayBuffer* value) {
  member_signature_ = value;
has_signature_ = true;
DCHECK(member_signature_);
}




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_authenticator_output_ = false;
bool has_signature_ = false;

Member<DOMArrayBuffer> member_authenticator_output_;
Member<DOMArrayBuffer> member_signature_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_AUTHENTICATION_EXTENSIONS_DEVICE_PUBLIC_KEY_OUTPUTS_H_
