/*
 * Copyright 2019 Google Inc.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef UTIL_CANONICAL_ERRORS_H_
#define UTIL_CANONICAL_ERRORS_H_

#include <string>

#include "third_party/private-join-and-compute/src/util/status.h"

namespace private_join_and_compute {

Status InternalError(const std::string& message);
Status InvalidArgumentError(const std::string& message);

bool IsInternal(const Status& status);
bool IsInvalidArgument(const Status& status);

}  // namespace private_join_and_compute

#endif  // UTIL_CANONICAL_ERRORS_H_
